\documentclass{scrarticle}
\usepackage{hyperref}
\usepackage{titling}
\usepackage{graphicx}
\usepackage{float}
\usepackage{booktabs}
\usepackage{color}
\usepackage{tikz}
\usepackage{pgfgantt}
\usepackage{rotating}
\pagenumbering{arabic}

%Let's define some awesome new ganttchart elements:
\newganttchartelement{orangebar}{
    orangebar/.style={
        inner sep=0pt,
        draw=red!66!black,
        very thick,
        top color=white,
        bottom color=orange!80
    },
    orangebar label font=\slshape,
    orangebar left shift=.1,
    orangebar right shift=-.1
}

\newganttchartelement{bluebar}{
    bluebar/.style={
        inner sep=0pt,
        draw=purple!44!black,
        very thick,
        top color=white,
        bottom color=blue!80
    },
    bluebar label font=\slshape,
    bluebar left shift=.1,
    bluebar right shift=-.1
}

\newganttchartelement{greenbar}{
    greenbar/.style={
        inner sep=0pt,
        draw=green!50!black,
        very thick,
        top color=white,
        bottom color=green!80
    },
    greenbar label font=\slshape,
    greenbar left shift=.1,
    greenbar right shift=-.1
}

\newganttchartelement{graybar}{
    graybar/.style={
        inner sep=0pt,
        draw=gray!50!black,
        very thick,
        top color=white,
        bottom color=gray!80
    },
   graybar label font=\slshape,
   graybar left shift=.1,
   graybar right shift=-.1
}

\newganttchartelement{yellowbar}{
    yellowbar/.style={
        inner sep=0pt,
        draw=white,
        thick,
        top color=white,
        bottom color=white
    },
   yellowbar label font=\slshape,
   yellowbar left shift=.1,
   yellowbar right shift=-.1
}

\input{solidity-highlighting}


\begin{document}
\title{Integrating IoT in a Decentralized
Renting Application} %TODO: Fill in project name
\author{%TODO: Fill in your names
	Lieb, Alexander (Alexander.Lieb@online.de) 
	\and \\
	Rüdesheim, Lennard (lennard.ruedesheim@stud.tu-darmstadt.de)
%TODO uncomment for more authors
%	\and \\
%	LastName3, FirstName3
%	\and \\
%	LastName4, FirstName4
}
%\author{team member 1\\ team member 2\\ team member 3} %TODO: Fill in your names
\input{titlepage_progress_report}
\clearpage

\paragraph{Abstract.}
\begin{abstract}
%Summarize the motivation and main concepts of your project (1/2 page). 
The business model of the sharing economy is based on interactions between the consumers of a platform. Popular examples for platforms in the market are Airbnb and Uber. They offer a service for users to rent their flat or a driving service. In this setting the platform provider has the power to decide who has access to his services and can demand significant fees for users. There is also a lack of privacy for the participants.

We want to develop a Decentralised App (DAPP) based on a smart contract  on the Ethereum blockchain to allow transactions between an owner of a product and a renter, so that no such platform provider is needed. Our application shall enable users to rent their bike. In this application we want to integrate an IoT device through that we want to reduce the effort for the users. The IoT device shall control the lock of a bike and should be able to locate it. Thereby the location of the bike can be used to determine the fee for renting and to make sure that the bike can only be returned at certain positions. 

%An additional goal is to minimize the gas costs of the application. This is important
%since the fees an user has to pay for using the DAPP should be small compared to the
%costs using a traditional platform provider.
\end{abstract}

\newpage
\section{Status Report}

Until the first status report, we have worked on our first two milestones. The first milestone was already finished, while the second was still in progress, due to missing and failing hardware. Today, we have finished milestone two and three in the last four weeks. That means that we are in time, even some hardware was missing or failing for several weeks.

We created a working renting system including an working IoT device connected to the rinkeby blockchain through the web3.py library. The IoT device is able to locate itself, to measure distances, to open and close a bike lock, and to interact with a smart contract on the blockchain. A user is able to rent a bike, which leads to the automatic opening of the bikelock, and to return a bike, which leads to the automatic closing of the bikelock and the post of the covered distance. Also, an user owning a bike can get part of the system by adding the bike to the contract.

In the following sections, the three finished milestones are described and an outlook on future work is given.

\subsection{Milestone: Working Renting System}

The first milestone included three user stories. The first one was, that a user has to be able to add a bike to the application. The second user story was, that a user has to be able to rent an offered bike, which is available. The last user story was, that a user has to be able to return a bike, (s)he rented before.

To fulfill all of these, we developed a DAPP, using Truffle, Ganache, Metamask, Google Chrome, Mozilla Firefox and the web3.js javascript library. Using this DAPP, a user is able to announce a bike for availability, hirer a bike, return a bike, and remove his/her bike from the system. The system is city-based, which means, that each city has its own contract and the user can choose the city. If there is no contract for the searched region, the user can deploy and register one by himself/herself.

Appendix A shows some impressions of the user interface, while Appendix B shows the code for the two basic contracts. There is at least one master contract needed. The address of the master contract is hardcoded in the DAPP and represents a meeting point for all users who want to participate in the system. Each city, which is part of the system, gets its own city contract, which has to be registered at the master contract. Therefore each user can choose the city to prevent that each user has to search through all bike offers in the world. This also prevents, as the reader can see in the following sections, that an IoT device is overwhelmed by events. Since each IoT device listens for all events at the contract, it is connected to, adding all bikes to a single contract would result into a lack of scalability. By having an own contract for each city, the events received by the IoT device are prefiltered.

\subsection{Milestone: IoT device is working}

The second milestone included three user stories. The first one was, that the IoT device has access to GPS data, provided by a GPS modul. The second user story was, that the IoT device can access the internet through an LTE stick. The third user story was about the ability to lock and unlock the bike.

To fulfill the first user story, we implemented a python module, which enables a developer to get up to date information about time, latitude, and longitude. Appendix C shows this module, which basically consists of two classes. The gpsdata class is a data-only class, which is used to store the actual time and position. This class is also returned, in case another python module uses this. The gpsgetter starts a new thread, which accesses the serial console and updates the data. Its using an own thread for accessing the serial console where the GPS module is attached. We soldered some pins to the GPS board to have a stable connection.

To fulfill the second user story, the IoT device needed an working LTE stick. The configuration for this was fastly done and now the LTE stick registers itself automatically as an virtual interface, which can be used to access the internet.

For the last user story, the production of a bike lock, using a step motor was necessary. We used a solid iron rod and gouged two holes into it. In one hole, we cutted a female screw thread, while the step motor is plugged into the other hole. When a screw is turned into the first hole, it fixes the step motor, making it possible to move the bike lock. This is shown in figures \ref{fig:BikelockAllParts} to \ref{fig:BikelockFinished}.

\begin{figure}[H]  
  \begin{minipage}[b]{0.5\linewidth}
    \centering
    \includegraphics[width=.95\linewidth]{img/first.jpg} 
    \caption{All parts of the bikelock}
    \label{fig:BikelockAllParts}
    \vspace{4ex}
  \end{minipage}%%
  \begin{minipage}[b]{0.5\linewidth}
    \centering
    \includegraphics[width=.95\linewidth]{img/second.jpg} 
    \caption{Iron Rod is placed} 
    \vspace{4ex}
  \end{minipage} 
  \begin{minipage}[b]{0.5\linewidth}
    \centering
    \includegraphics[width=.95\linewidth]{img/third.jpg} 
    \caption{Iron Rod is placed, frontal} 
    \vspace{4ex}
  \end{minipage}%% 
  \begin{minipage}[b]{0.5\linewidth}
    \centering
    \includegraphics[width=.95\linewidth]{img/fourth.jpg} 
    \caption{Bikelock is finished}
    \label{fig:BikelockFinished}
    \vspace{4ex}
  \end{minipage}
\end{figure}

\subsection{Milestone: IoT device is connected to the contract}

The third and last milestone also included three User Stories. While the first was about the ability of the bike to post its travelled distance, the other two were about the ability of a user to open and close the bikelock through the Smart Contract.

For this milestone, the connectivity between the IoT Software and the rinkeby blockchain was most important. The web3.py library was used to enable this functionality. The library is able to send raw transactions using infura and a local key node and is able to receive events posted by the latest block. The IoT Software is running an infinite loop, watching for the events of the contract the IoT device is connected to and depending on the received events, it starts further activity.

For the first User Story, we used the previously written python module for communicating with the GPS module, and the python geopy library \cite{geodesic}. About each 30 seconds, our software checks for new gps data and calculates the distance between the previous position and the new position. This results into a good approximation of the distance. Nevertheless, the future work sections will show how this can be further improved, e.g. when the gps is not able to receive data. When the bike receives the information that the user wants to return the bike, it sends the travelled distance to the blockchain.

For the other two User Stories, the previously built bike lock was used. When the IoT device receives the event that a user wants to rent a bike, it opens the bike lock, when the IoT devices receives the event that a user wants to return a bike lock, the bike lock is closed again.

The protocol for renting a bike can be found in Figure \ref{fig:RentProtocol}, the protocol for returning a bike can be found in Figure \ref{fig:ReturnProtocol}.
\begin{figure}[H]
    \centering
    \includegraphics[width=.95\linewidth]{img/rent_bike_protocol.pdf} 
    \caption{The protocol for renting a bike}
    \label{fig:RentProtocol}
\end{figure}

\begin{figure}[H]
    \centering
    \includegraphics[width=.95\linewidth]{img/return_bike_protocol.pdf} 
    \caption{The protocol for returning a bike} 
    \label{fig:ReturnProtocol}
\end{figure}

\newpage

\subsection{Future Work}

There are many tasks to do in the future, so it will not be possible to do all of them until the end of the project. Therefore we divide the tasks into three categories. While the first category is about tasks we want to implement, the second is about tasks we try to implement as long as we are not running out of time, and the last category is about tasks we will not implement, leaving them as future work.

\subsubsection{First Category: Tasks we want to do}

The most important task is to secure the secret key of the IoT device. Right now, the secret key is placed in plaintext at a text file on the device. This enables an attacker to extract the key and fake transactions to the smart contract. Several countermeasures are possible here, we are going to implement at least one. Also we need to create an upper time limit, a bike can be used. After this time limit, the bike has to be returned by the hirer. As already mentioned, there is also a need for a fallback implementation, in case the gps module does not receive any signal. Also an investigation on further attack vectors and possible countermeasures is needed.

\subsubsection{Second Category: Tasks we might do}

There are also tasks, which are nice to have but not necessary for a proof-of-concept, as it is done here. Therefore we might implement them, but only if we are not running out of time. One of them is, that while Google Maps is doing well in finding a position given by our coordinates, we use Openstreet Map for our showcase. This results into the fact that the map is sometimes pointing to a place, a few hundred meters away from the place of the bike. The reason for this is unknown right now and further investigation is needed. Another possible task comes from the fact that every time the IoT device boots, it asks the smart contract for its bike id. This might not be necessary as long as the bike id stays the same. Therefore a better bike id handling might also be in the scope of our work.

\subsubsection{Third Category: Remaining Tasks}

Last but not least, creating a suitable case to defend against physical attacks is of course necessary for a bikelock used in the wild. But due to the fact, that we are focusing on the software part and a stable case is obviously possible to build and therefore not part of a proof-of-concept implementation, we leave this as future work.


\newpage

\section{Updated Project Plan}

The project plan has not changed since the last progress report, except that the User Stories and Milestones are all done now. This can be seen in Table \ref{tab:mile}. In Figure \ref{fig:plan} the Gantt-Chart is shown, which is also the same as in the previous progress report.

\begin{table}[H]
 \begin{tabular}{p{4cm}p{5cm}p{5cm}}
\toprule
\textbf{Milestones} & \textbf{Open User Stories}  &  \textbf{ Finished User Stories }\\
\midrule
\textbf{Working \linebreak Renting System} \newline (finished)& - & US1: User can add a bike (Sprint 1)   \\  
    &  & \\
 & &US2: User is able to rent a bike (Sprint 1) \\
     &  & \\
  & & US3: User is able to release a bike (Sprint 1)\\
   \midrule
  \textbf{IoT device is working}  \newline (finished) & -  & US6: User can get GPS data from RPI (Sprint 2)\\
    &  &US4: RPI can access the LTE Stick (Sprint 3)\\
    & & \\  
    & &US5: The RPI can lock the bike (Sprint 4)\\
    \midrule
    \textbf{IoT device is connected to the \newline contract} \newline (finished) & -  & US7: Smart Contract locks the bike when it is released (Sprint 4) \\
    & & US8: Bike posts the distance it has traveled (Sprint 3) \\
    & & \\
    & & US9: User is able to unlock the bike through the Smart Contract (Sprint 4) \\
\bottomrule
 \end{tabular}
 \caption{Project Milestones}  \label{tab:mile}
\end{table}

\newpage

%\begin{table}[!h]
% \begin{tabular}{p{1.5cm}p{1.9cm}p{1.9cm}p{1.9cm}p{1.9cm}p{1.9cm}p{1.9cm}}
%\toprule
%\textbf{Sprint} & 27.04 \newline- 11.05 & 11.05 \newline- 25.05 & 25.05 \newline- 08.06 & 08.06 \newline- 22.06 & 22.06 \newline- 06.07 & 06.07 \newline- 20.07  \\
%\midrule
%\textbf{User Stories} & US 1,2,3 & US 6 \newline Progess Report 1 & US 4,8 & US 5,7,9 \newline Progress Report 2 &  Final report & TEE Integration\newline (optional)\\
%\bottomrule
% \end{tabular}
 %\caption{Project Plan}  \label{tab:plan}
%\end{table}

\begin{minipage}{\linewidth}
\centering
\begin{sideways}

\begin{ganttchart}[
    hgrid style/.style={black, dotted},
    vgrid={*5{black,dotted}, *1{white, dotted}, *1{black, dashed}},
    x unit=2mm,
    y unit chart=7.5mm,
    y unit title=10mm,
    time slot format=isodate,
    group label font=\bfseries \Large,
    link/.style={->, thick}
    ]{2020-04-27}{2020-07-26}
    \gantttitlecalendar{month=name, week}\\

    \ganttgroup[
        group/.append style={fill=orange}
    ]{Milestone 1}{2020-04-27}{2020-05-11}\\ [grid]
    \ganttorangebar[
        name=US1
    ]{US1}{2020-04-27}{2020-05-11}\\ [grid]
    \ganttorangebar[
        name=US2
    ]{US2}{2020-04-27}{2020-05-11}\\ [grid]
    \ganttorangebar[
        name=US3
    ]{US3}{2020-04-27}{2020-05-11}\\ [grid]


    \ganttgroup[
        group/.append style={fill=blue}
    ]{Milestone 2}{2020-05-11}{2020-06-22} \\[grid]
    \ganttbluebar{US4}{2020-05-25}{2020-06-08}\\ [grid]
    \ganttbluebar{US5}{2020-06-08}{2020-06-22} \\[grid]
    \ganttbluebar{US6}{2020-05-11}{2020-05-25} \\[grid]

    \ganttgroup[
        group/.append style={fill=green}
    ]{Milestone 3}{2020-05-25}{2020-06-22} \\[grid]
    \ganttgreenbar{US7}{2020-06-08}{2020-06-22}\\ [grid]
    \ganttgreenbar{US8}{2020-05-25}{2020-06-08} \\[grid]
    \ganttgreenbar{US9}{2020-06-08}{2020-06-22} \\[grid]

  \ganttgroup[
        group/.append style={fill=yellow}
    ]{Secure Storage}{2020-06-22}{2020-07-12} \\[grid]
 

    \ganttgroup[
        group/.append style={fill=gray}
    ]{Submissions}{2020-04-27}{2020-07-19} \\[grid]
    \ganttgraybar{Progress Report 1}{2020-05-18}{2020-05-24}\\ [grid]
    \ganttgraybar{Progress Report 2}{2020-06-15}{2020-06-21} \\[grid]
    \ganttgraybar{Final Report}{2020-06-22}{2020-07-19} \\[grid]
    
      

\end{ganttchart}

\end{sideways}
\captionof{figure}{Project Plan } \label{fig:plan}
\end{minipage}
\newpage
\section*{Appendix A}

\begin{figure}[H]
  \centering
  \begin{tabular}{@{}c@{\hspace{.5cm}}c@{}}
    \includegraphics[page=1,width=0.8\textwidth]{img/Screenshot_Master_UI.png}
  \end{tabular}
  \caption{Screenshot of the User Interface, Master Contract}
\end{figure}

\begin{figure}[H]
  \centering
  \begin{tabular}{@{}c@{\hspace{.5cm}}c@{}}
    \includegraphics[page=1,width=0.8\textwidth]{img/Screenshot_City_UI.png} 
  \end{tabular}
  \caption{Screenshot of the User Interface, City Contract (1)}
\end{figure}


\begin{figure}[H]
  \centering
  \begin{tabular}{@{}c@{\hspace{.5cm}}c@{}}
    \includegraphics[page=1,width=0.7\textwidth]{img/Screenshot_Map.png}
  \end{tabular}
  \caption{Screenshot of the User Interface, City Contract (2)}
\end{figure}



\newpage
\section*{Appendix B}

\begin{lstlisting}[language=Solidity]
pragma solidity 0.5.16;

contract Master{
  struct city {
    string country;
    string state;
    string city;
    address place;
  }

  event cityRegisteredEvent(
    string name
  );
  
  city[] public registeredCities;

  function getNoOfCities() external view returns (uint) {
    return registeredCities.length;
  }

  function getCity(uint which) external view returns (string memory){
    return string(abi.encodePacked(registeredCities[which].city, ",", registeredCities[which].state, ",", registeredCities[which].country));
  }

  function getPlace(uint which) external view returns (address) {
    return registeredCities[which].place;
  }
  
  function register(string calldata _country, string calldata _state, string calldata _city, address _place) external {
    registeredCities.push(city(_country, _state, _city, _place));
    emit cityRegisteredEvent(_city);
  }
  
}
\end{lstlisting}

\newpage

\begin{lstlisting}[language=Solidity]
pragma solidity 0.5.16;
import "../../Master_Contract/contracts/Master.sol";

contract Renting{

     struct Bike{
       address owner;
       address bike_account;
       uint hirer_refund;
       uint base_price;
       uint cpkm; // costs per km
       // 0 indicates that this bike is not hired yet
       address hirer;
       uint amount_hirer_paid;
       uint lat;
       uint lon;
       bool started_return;
    }

    mapping(uint => Bike) public bikes;
    mapping(address => uint) public refunds;
    
    uint public bikeCount;

    // TODO: find a "good" value or add it to the constructor
    uint public constant owner_refund = 42;
    
    //events
    event addBikeEvent(
       address bikeAccount,
       uint bikeId,
       uint lat,
       uint lon
    );

    event rentBikeEvent(
      address bikeAccount 
    );

    event returnBikeEvent(
      address bikeAccount
    );

    event removeBikeEvent(
      address bikeAccount
    );

    event refundEvent(
      address account
    );

    event correctLocationEvent(
      uint bikeId
    );

    event bikeIdEvent(
      address bike,
      bool exists,
      uint bikeId
    );

    event bikeStateEvent(
      address bike,
      bool available,
      bool started_return,
      uint lat,
      uint lon
    );
    
    // Constructor
    constructor(string memory _country, string memory _state, string memory _city, address _master_address) public{

	Master m = Master(_master_address);
	m.register(_country, _state, _city, address(this));
	
    }

    function getBikeState(uint bikeId) external {
      require(bikes[bikeId].bike_account == msg.sender);
      emit bikeStateEvent(bikes[bikeId].bike_account, (bikes[bikeId].hirer == address(0)), bikes[bikeId].started_return, bikes[bikeId].lat,  bikes[bikeId].lon);
    }

    function getMyBikeId() external {
      bool exists = false;
      uint id = 0;
      for(uint i = 1; i < bikeCount+1; i++) {
	if(bikes[i].bike_account == msg.sender) {
	  exists = true;
	  id = i;
	  i = bikeCount;
	}
      }
      emit bikeIdEvent(msg.sender, exists, id);
    }
    
    function bikeLockClosed(uint _bikeId, uint _lat, uint _lon, uint _km_travelled) external{
      require(bikes[_bikeId].bike_account == msg.sender, "this is not the correct bike");

      bikes[_bikeId].hirer = address(0);
      bikes[_bikeId].lat = _lat;
      bikes[_bikeId].lon = _lon;

      bikes[_bikeId].started_return = false;
      uint fund;
      uint owner_fund;
      if (bikes[_bikeId].amount_hirer_paid < (bikes[_bikeId].base_price + _km_travelled*bikes[_bikeId].cpkm)){
        fund = 0;
        owner_fund = bikes[_bikeId].amount_hirer_paid;
      } else {
        fund = bikes[_bikeId].amount_hirer_paid - bikes[_bikeId].base_price - _km_travelled*bikes[_bikeId].cpkm;
        owner_fund = bikes[_bikeId].base_price + _km_travelled*bikes[_bikeId].cpkm;
      }
      bikes[_bikeId].amount_hirer_paid = 0;
      
      refunds[bikes[_bikeId].owner] += owner_fund;
      refunds[bikes[_bikeId].hirer] += fund;
    }

    function correctLocation(uint _bikeId, uint _lat, uint _lon) external{
      require(msg.sender == bikes[_bikeId].bike_account, "Wrong bike account");
      bikes[_bikeId].lat = _lat;
      bikes[_bikeId].lon = _lon;
      emit correctLocationEvent(_bikeId);
    }
    
    //adds bike to the bikes mapping with the specified costs
    function addBike(uint _base_price, uint _cpkm, uint _hirer_refund, address _bikeAccount, uint _lat, uint _lon) external payable{
      require(msg.value >=  owner_refund);
      bikeCount++;
      uint bikeId = bikeCount;
      bikes[bikeId] = Bike(msg.sender, _bikeAccount, _hirer_refund, _base_price, _cpkm, address(0), 0, _lat, _lon, false);
      emit addBikeEvent(_bikeAccount, bikeId, _lat, _lon); 
    }


    function rentBike(uint _bikeId) external payable{
      require(bikes[_bikeId].owner != address(0), "Bike-ID not valid");
      require(bikes[_bikeId].hirer == address(0), "Bike is already rented");
      require(bikes[_bikeId].hirer_refund + bikes[_bikeId].base_price <= msg.value + refunds[msg.sender],  "Refund to low");

      refunds[msg.sender] += msg.value;
      refunds[msg.sender] -= bikes[_bikeId].hirer_refund + bikes[_bikeId].base_price;
      bikes[_bikeId].amount_hirer_paid = bikes[_bikeId].hirer_refund + bikes[_bikeId].base_price;
      bikes[_bikeId].hirer = msg.sender;
      
      emit rentBikeEvent(bikes[_bikeId].bike_account); 
    }

    function returnBike(uint _bikeId) external{
      require(bikes[_bikeId].owner != address(0), "Bike-ID not valid");
      require(bikes[_bikeId].hirer == msg.sender, "You are not the renter of the bike");

      bikes[_bikeId].started_return = true;
      
      emit returnBikeEvent(bikes[_bikeId].bike_account);
    }

    function removeBike(uint _bikeId) external{
      require(bikes[_bikeId].owner != address(0), "Bike-ID not valid");
      require(bikes[_bikeId].hirer == address(0), "Bike is rented");
      require(bikes[_bikeId].owner == msg.sender, "You are not the owner of the bike");
      refunds[bikes[_bikeId].owner] += owner_refund;
      delete bikes[_bikeId];
      emit removeBikeEvent(bikes[_bikeId].bike_account);
    }

    function payIn() external payable {
      refunds[msg.sender] += msg.value;
    }

    // if amount == 0 all eth is sent back
    function refund(uint amount) external{
      require(amount <= refunds[msg.sender], "you cannot withdraw more eth than you have");
      if (amount == 0) {
	amount = refunds[msg.sender];
      }
      refunds[msg.sender] -= amount;
      emit refundEvent(msg.sender); 
      msg.sender.transfer(amount);
    }
}
\end{lstlisting}
\newpage

\section*{Appendix C}

\begin{lstlisting}[language = python]
import os
import struct
from threading import Thread
import time
from serial import Serial
import logging

class gpsdata:
    def __init__(self, time, n, e):
        self.time = time
        self.n = n
        self.e = e

    def get_time(self):
        return self.time

    def get_n(self):
        return self.n

    def get_e(self):
        return self.e

class gpsgetter:
    
    def helper(loself):
        ser=Serial('/dev/ttyS0')
        ser.flushInput()
        while True:
            try:
                bytes = ser.readline()
                text = bytes.decode("utf-8")
                if (text.find("GPGGA") >= 0):
                    arr = text.split(',')
                    loself.set_values(gpsdata(arr[1], arr[2], arr[4]))
                    time.sleep(30)
                    ser.flushInput()
            except Exception as ex:
                logging.warning(ex)
                logging.warning('continue anyway')
            
    def start_getter(self):
        self.actual = gpsdata(-1, -1, -1)
        self.runner = Thread(target=gpsgetter.helper, args=[self])
        self.runner.start()

    def get_values(self):
        while(len(self.actual.get_n()) == 0 or self.actual.get_n()[0] == '-'):
                time.sleep(10)
        return self.actual

    def set_values(self, new):
        self.actual = new
\end{lstlisting}


\bibliographystyle{unsrt}
\bibliography{ref}

\end{document}
